#include <pthread.h>
#include <math.h>

#define LOOPS 100
#define SIZE (512*1024)
#define THREADS 8

float* f[THREADS];
pthread_cond_t c = PTHREAD_COND_INITIALIZER;
pthread_mutex_t m = PTHREAD_MUTEX_INITIALIZER;
int r;

/* thread code */
void* calculate(void* arg) {
  int i,num=(int)arg;
  int flag=1<<num;
  float *ff=f[num];
  float x1,x2,x;
  for(;;) {
    pthread_mutex_lock(&m);
    while((r&flag)==0) pthread_cond_wait(&c,&m);
    pthread_mutex_unlock(&m);

    /* unsinnige Berechnung,
       Rand-Kommunikation vernachlssigt */
    for(i=0;i<SIZE-2;i++) {
	x1=ff[i+1];
	x2=ff[i+2];
	x=(x1*x2)/sqrt(abs(x1*4+x2*8)+1);
	ff[i]=x;
    };

    pthread_mutex_lock(&m);
    r&=~flag;
    pthread_cond_broadcast(&c);
    pthread_mutex_unlock(&m);
  };
};

main() {
  int i,j;
  pthread_t t[THREADS];

  r=(1<<THREADS)-1;

  for(i=0;i<THREADS;i++) {
    f[i]=(float*)malloc(sizeof(float)*SIZE);
    pthread_create(&t[i],0,calculate,(void*)i);
  };

  for(j=0;j<LOOPS;j++) {

    pthread_mutex_lock(&m);
    while(r!=0) pthread_cond_wait(&c,&m);
    pthread_mutex_unlock(&m);
    
    pthread_mutex_lock(&m);
    r=(1<<THREADS)-1;    
    pthread_cond_broadcast(&c);
    pthread_mutex_unlock(&m);

  };

};

